#delimit;
clear;
set mem 50m;

use IFSdataforES.dta;

keep if couple==1;
gen unit_id=hh_id*10+benunit;sort unit_id sex;
keep unit_id sex allearnings hours wage work numch age kids w wscaled educ 
earncentile dispinc0 mtr0 ptr0 ptr_20hrs0 ptr_40hrs0 nettax0;
reshape wide  allearnings hours wage work numch age kids w wscaled educ 
earncentile dispinc0 mtr0 ptr0 ptr_20hrs0 ptr_40hrs0 nettax0,
i(unit_id) j(sex);
keep if allearnings1>=1;
gen partspouse=0;replace partspouse=1 if allearnings2>=20;

cumul allearnings1 [w=w1], gen(perc1);

gen perc1t=round(100*perc1,1);
gen allmed2=allearnings2;

replace mtr01=0.90 if mtr01>=.90;
replace mtr02=0.90 if mtr02>=.90;
gen ability=allearnings1/(1-mtr01)^0.25;
cumul allearnings1 [w=w1], gen(perc2);
gen percability=round(100*perc2,1);

gen partweight=1;replace partweight=1/(1-ptr02)^0.5 if partspouse==1;

gen weight=w2*partweight;

* simulation data for EMA paper;

replace ability=2000 if ability>2000;
keep if ability>=1;

gen perc=0;
replace perc=60*ability/800 if ability<800;
replace perc=60+40*log(ability/800)/log(2000/800) if ability>=800;

replace perc=round(perc,1);
gen coun=w2;

gen mtr0=mtr01*(1-partspouse);
gen mtr1=mtr01*(partspouse);

sum coun;

collapse (mean) ability partspouse allearnings2 allearnings1 ptr02 mtr0 mtr1 mtr01 nettax01 nettax02 (sum) coun, by(perc);
replace mtr0=mtr0/(1-partspouse);replace mtr1=mtr1/(partspouse);

gen abmin=0;
replace abmin=(perc)*800/60 if perc<=60;
replace abmin=800*(2000/800)^((perc-60)/40) if perc>=60;
gen abmax=0;
replace abmax=(perc+1)*800/60 if perc<=60;
replace abmax=800*(2000/800)^((perc+1-60)/40) if perc>=60;

gen fn=coun/(abmax-abmin);

order abmin abmax fn ability coun partspouse allearnings2 mtr0 mtr1 ptr02 mtr01 allearnings1 nettax01 nettax02;

outfile abmin abmax fn ability coun partspouse allearnings2 mtr0 mtr1 ptr02 mtr01 using simudat\UKdata.dat, replace wide;

sum ability allearnings2 allearnings1 mtr0 mtr1 ptr02 mtr01 ptr02 nettax01 nettax02 [w=coun];

twoway line fn ability;
twoway line mtr0 mtr1 ptr02 ability;

twoway line partspouse ability;
twoway line allearnings2 ability;
