% 2/15/2008
% plot simulations, final version for EMA resubmission;      

% cd c:\manu\papers\womenlaborsupply\matlab\summer06;

% Figure 3: empirical;

load simudat\UKfig.mat;
nun=max(size(fnorg));fnorg(nun)=fnorg(nun-1);
n=n*52*(258/0.75)/1000;nuk=nuk/1000;
nmax=100;nmin=0;
%Pbench=P;Pavbench=Pav;
%tau0b=tau(1,:);tau1b=tau(2,:);dTb=tauspouse;
  
subplot(2,2,1), plot(nuk,tau0uk,'--',nuk,tau1uk,nuk,tauspouseuk,'-.','LineWidth',1),
 axis([nmin nmax 0 1]),
 grid,
 text(0,1.2,'Figure 3: Numerical Simulations: Current System','FontSize',14),
title('A. Current Tax Rates'),
 xlabel('Potential Primary Earnings n (annual 000s Pounds)','FontSize',10), 
 set(gca,'xtick',[0 20 40 60 80 100],'FontSize',10),
 ylabel('Tax Rates','FontSize',10),
 set(gca,'ytick',[0 .2 .40 .60 .80 1],'FontSize',10),
 h_legend=legend('T^{/}_0 (one earner couples)','T^{/}_1 (two earner couples)','\tau (secondary earner)',1);set(h_legend,'FontSize',9),
 
subplot(2,2,2), plot(n,fn,norg*52*(258/0.75)/1000,fnorg,'--','LineWidth',1),
 axis([nmin nmax 0 0.7]),
 grid,
 title('B. Primary Earnings Distribution'),
 xlabel('Potential Primary Earnings n (annual 000s Pounds)','FontSize',10), 
 set(gca,'xtick',[0 20 40 60 80 100],'FontSize',10),
 ylabel('Density f(n)','FontSize',10),
 set(gca,'ytick',[0 .2 .40 .60],'FontSize',10),
 h_legend=legend('Smoothed f(n)','Empirical f(n)',1);set(h_legend,'FontSize',9); 
 
subplot(2,2,3), plot(norg*52*(258/0.75)/1000,partspouse,'LineWidth',1),
 axis([nmin nmax 0 1]),
 grid,
 title('C. Spousal Participation Rate'),
  xlabel('Potential Primary Earnings n (annual 000s Pounds)','FontSize',10), 
 set(gca,'xtick',[0 20 40 60 80 100],'FontSize',10),
 ylabel('Fraction Spouses Working','FontSize',10),
 set(gca,'ytick',[0 .2 .40 .60 .80 1],'FontSize',10),
 text(0, -0.25, 'Notes: Computations are based on the British Family Resource Survey for 2004/05 and TAXBEN tax/transfer calculator.','FontSize',9),
 

subplot(2,2,4), plot(norg*52*(258/0.75)/1000,earnspouse*52/1000,'LineWidth',1),
 axis([nmin nmax 0 20]),
 grid,
 title('D. Average Spousal Earnings (conditional on work)'),
  xlabel('Potential Primary Earnings n (annual 000s Pounds)','FontSize',10), 
 set(gca,'xtick',[0 20 40 60 80 100],'FontSize',10),
 ylabel('Spousal Earnings (000s Pounds)','FontSize',10),
 set(gca,'ytick',[0 5 10 15 20],'FontSize',10);
 
 print -dps simudat\fig3EMA.ps;
  
 clear;
 % Figure 4: simulations;
 
load simudat\simuemagam1.mat;
tau0eta=tau(1,:);tau1eta=tau(2,:);dTeta=tauspouse;
load simudat\simuemagam1corr.mat;
tau0epsi=tau(1,:);tau1epsi=tau(2,:);dTepsi=tauspouse;
load simudat\simuemagam2.mat;
tau0etaep=tau(1,:);tau1etaep=tau(2,:);dTetaep=tauspouse;
load simudat\simuemagam1elarge.mat;
tau0gamma=tau(1,:);tau1gamma=tau(2,:);dTgamma=tauspouse;

n=n*52*(258/0.75)/1000;
nmax=100;nmin=1;
Pbench=P;Pavbench=Pav;

subplot(2,2,1), plot(n,tau0eta,'--',n,tau1eta,n,dTeta,'-.','LineWidth',1), 
title('A. Benchmark (no correlation, \gamma=1, \eta=0.5, \epsilon=0.25)'),
 axis([nmin nmax 0 1]),
 grid,
 text(0,1.2,'Figure 4: Optimal Tax Simulations','FontSize',14),
  xlabel('Potential Primary Earnings n (annual 000s Pounds)','FontSize',10), 
 ylabel('Optimal Tax Rates','FontSize',10),
 h_legend=legend('T^{/}_0 (one earner couples)','T^{/}_1 (two earner couples)','\tau (secondary earner)',1);set(h_legend,'FontSize',10);
 
 subplot(2,2,2), plot(n,tau0epsi,'--',n,tau1epsi,n,dTepsi,'-.','LineWidth',1), 
 title('B. Positive Ability Correlation across Spouses'),
 axis([nmin nmax 0 1]),
 grid,
 xlabel('Potential Primary Earnings n (annual 000s Pounds)','FontSize',10), 
 ylabel('Optimal Tax Rates','FontSize',10),
 h_legend=legend('T^{/}_0','T^{/}_1','\tau',1);set(h_legend,'FontSize',10);
 
 subplot(2,2,3), plot(n,tau0etaep,'--',n,tau1etaep,n,dTetaep,'-.','LineWidth',1), 
 title('C. Higher redistributive Tastes, \gamma=2'),
 axis([nmin nmax 0 1]),
 grid,
  xlabel('Potential Primary Earnings n (annual 000s Pounds)','FontSize',10), 
 ylabel('Optimal Tax Rates','FontSize',10),
 h_legend=legend('T^{/}_0','T^{/}_1','\tau',3);set(h_legend,'FontSize',10),
 text(0, -0.25, 'Notes: Computations are based on the British Family Resource Survey for 2004/05 and TAXBEN tax/transfer calculator.','FontSize',9);
 
 subplot(2,2,4), plot(n,tau0gamma,'--',n,tau1gamma,n,dTgamma,'-.','LineWidth',1), 
 title('D. Higher Primary Earner Elasticity, \epsilon=0.5'),
 axis([nmin nmax 0 1]),
 grid,
  xlabel('Potential Primary Earnings n (annual 000s Pounds)','FontSize',10), 
 ylabel('Optimal Tax Rates','FontSize',10),
 h_legend=legend('T^{/}_0','T^{/}_1','\tau',1);set(h_legend,'FontSize',10);
 
print -dps simudat\fig4EMA.ps;
 
