function y = testfct(x,a,b)

%BETAFCT Incomplete beta function.
%   Y = BETAFCT(X,Z,W) computes the incomplete beta function for
%   corresponding elements of X, Z, and W.  The elements of X must be
%   in the closed interval [0,1].  The arguments X, Z and W must all
%   be the same size (or any of them can be scalar).
%
%   The incomplete beta function is defined as
%
%     I_x(a,b) =  integral from 0 to x of t.^(a-1) .* (1-t).^(b-1) dt
%
% I use the development in series where I_x(a,b) = sum_n (x^(n+a)/(n+a))*(1-b)(2-b)..(n-b)/n!
% I insure precision of at least 10^(-10) because reminder of series truncated at n is at most (x^n/n)/(1-x)

if a>0 & b>0; 
    y=betainc(x,a,b)*beta(a,b);
end;

if a<=0 | b<=0;
    nn=(-log(10^(-10))-log(1-x))/(-log(x));nn=round(nn);
    nn=max(nn,20);nn=max(nn);
    coen=ones(1,nn+1);y=1/a;
    for n=1:nn;
        coen(n+1)=coen(n)*(n-b)/n;
        y=y+coen(n+1)*(x.^(n))/(a+n);
    end;
    y=y.*(x.^a);
end;
    
    
    %y=y-betainc(x,a,b)*beta(a,b);