% 10/25/2006
% program that solves the optimal tax formula directly
% for the intensive- discrete intensive couple model by iterative method
% second earner has intensive choice with discrete outcomes in number I;
% case I=1 replicates the binary program;

% start with a guess for T'0,.., T'I, then compute all V0,..,VI, z0,..,zI, g0,..,gI, lambda 
% subject to transversality and budget constraints

% then use FOC formulas for T'0,..T'I to iterate until you converge 

% I AM NOW TRYING LONGER TAIL BY USING ADAPTIVE iterative METHOD;


% cd c:\manu\papers\womenlaborsupply\matlab\summer06;


calib=0;corr=0;a=2;ema=1;nmin=.0001;I=1;k=2;etas=1/2;gamma=1;nmax=150;
if ema~=1;E=0;end;
 
I=1; % number of spouses earnings outcomes;

% elastiticity =1/k;
% Pareto parameter a;
% social welfare function CRRA gamma;
% etas participation second earner elasticity;

%k=3/2; nmax=250;corr=0;a=2;gamma=5;etas=1/3;calib=0;nmin=.0001;
eta=etas*ones(I,1); % elasticity of participation margin (not the true elasticity);

e=1/k; % intensive elasticity epsilon;
w=[0:1:I]'; % earnings of secondary earner;

%w=linspace(nmin,nmax,I+1)';
qmax=2*diff(w); % max cost of working; distribution of working costs is P(q)=(q/qmax)^eta, density p(q)=eta*q^(eta-1)/qmax^eta;

barh=ones(I,1)/I; % fraction of each type i=1,..,I;

%qmax=2*diff(w).*diff(w).^(1./eta); % alternative that works better;
precis=1;

epsi=0.02; % used to avoid corner effects but actually not used;

num=1000;
n=exp(linspace(log(nmin),log(nmax),num));
num=max(size(n));

% correlation between n and q;

if corr==0;qmax=qmax*ones(1,num);end; 
if corr==1;qmax=qmax*(3.5-(2.4/3)*(n-nmin))*0.4;end;
if corr==-1;qmax=qmax*(1+(4/3)*(n-nmin))*0.7;end;

fn=a*(nmin^a)./(n.^(1+a)); % density distribution of skills;
Fn=1-(nmin^a)./(n.^(a)); % cumulated distribution of skills;
const=1/(1-(nmin^a)/(nmax^a)); 
fn=fn*const;Fn=Fn*const;

%fn=ones(1,num)/(nmax-nmin); %uniform case;

% realistic case;
if calib==1;
    fn=min(ones(1,num),3^(1+a)./(n.^(1+a))); % nthr=3;
    fn=fn/trapz(n,fn);
end;

% calibrated version based on UK data, cf women1 prog in stata directory;
if ema==1;
    load simudat\UKdata.dat;
  
    % empirical measures;
    n=UKdata(:,1)'/(258/0.75);norg=n;fnorg=UKdata(:,3)';num2=max(size(n));
    tau0uk=UKdata(:,8)';tau1uk=UKdata(:,9)';tauspouseuk=UKdata(:,10)';
    earnspouse=UKdata(:,7)';partspouse=UKdata(:,6)';
      
    fn=tau0uk;fnaux=tau0uk;
    for jj=1:10;
        fnaux(1)=0.5*fn(1)+0.5*fn(2);
        fnaux(num2-1)=0.5*fn(num2-2)+0.5*fn(num2-1);
        for ii=2:num2-2;fnaux(ii)=fn(ii-1)*0.25+fn(ii)*0.5+fn(ii+1)*0.25;end;
    fn=fnaux;
    end;
    tau0uk=fn;
    fn=tau1uk;fnaux=tau1uk;
    for jj=1:10;
        fnaux(1)=0.5*fn(1)+0.5*fn(2);
        fnaux(num2-1)=0.5*fn(num2-2)+0.5*fn(num2-1);
        for ii=2:num2-2;fnaux(ii)=fn(ii-1)*0.25+fn(ii)*0.5+fn(ii+1)*0.25;end;
    fn=fnaux;
    end;
    tau1uk=fn;
    fn=tauspouseuk;fnaux=tauspouseuk;  
    for jj=1:10;
        fnaux(1)=0.5*fn(1)+0.5*fn(2);
        fnaux(num2-1)=0.5*fn(num2-2)+0.5*fn(num2-1);
        for ii=2:num2-2;fnaux(ii)=fn(ii-1)*0.25+fn(ii)*0.5+fn(ii+1)*0.25;end;
    fn=fnaux;
    end;
    tauspouseuk=fn;
    fn=earnspouse;fnaux=earnspouse;
    for jj=1:10;
        fnaux(1)=0.5*fn(1)+0.5*fn(2);
        fnaux(num2-1)=0.5*fn(num2-2)+0.5*fn(num2-1);
        for ii=2:num2-2;fnaux(ii)=fn(ii-1)*0.25+fn(ii)*0.5+fn(ii+1)*0.25;end;
    fn=fnaux;
    end;
    earnspouse=fn;
    fn=partspouse;fnaux=partspouse;
    for jj=1:10;
        fnaux(1)=0.5*fn(1)+0.5*fn(2);
        fnaux(num2-1)=0.5*fn(num2-2)+0.5*fn(num2-1);
        for ii=2:num2-2;fnaux(ii)=fn(ii-1)*0.25+fn(ii)*0.5+fn(ii+1)*0.25;end;
    fn=fnaux;
    end;
    partspouse=fn;
    nuk=n*(258/0.75)*52;  
    
    
    
    
    %plot(n,tauspouseuk,n,tau1uk,n,tau0uk);
    %glue;
   
    n(1)=nmin;n([num2:num])=exp(linspace(log(n(num2)),log(nmax),num-num2+1));
    fnorg=fnorg/trapz(norg,fnorg);
        
    % smoothing;
    fnaux=fnorg;fn=fnorg;
    
    for jj=1:20;
        fnaux(1)=0.5*fn(1)+0.5*fn(2);
        fnaux(num2-1)=0.5*fn(num2-2)+0.5*fn(num2-1);
        for ii=2:num2-2;fnaux(ii)=fn(ii-1)*0.25+fn(ii)*0.5+fn(ii+1)*0.25;end;
    fn=fnaux;
    end;
    fn=fn/trapz(norg,fn);
    
    
    Fn=zeros(size(fn));
    for jj=2:num2;Fn(jj)=trapz(n([1:jj]),fn([1:jj]));end;    
    CC=(1-Fn)./(norg.*fn);CC(1)=2*CC(2);CCorg=CC;CC([65:num])=1/a;
    
    n0=n(65);F0=Fn(65);fnnew=zeros(size(n));aux=zeros(size(fnnew));
    for jj=66:num;aux(jj)=-trapz(n([65:jj]),1./(n([65:jj]).*CC([65:jj])));end;    
    for jj=1:64;aux(jj)=trapz(n([jj:65]),1./(n([jj:65]).*CC([jj:65])));end;    
    fnnew=((1-F0)./(n.*CC)).*exp(aux);fnnew(1)=fnnew(2);
    fn=fnnew/trapz(n,fnnew);Fn=zeros(size(fn));
    for jj=2:num;Fn(jj)=trapz(n([1:jj]),fn([1:jj]));end;   
        
    PTR=0.283;
    if corr==0;qmax=diff(w)*(1-PTR)*0.65.^(-1/eta);end;
    if corr==1;
        part=ones(size(n));part([1:72])=(2/3)+(1/3)*(n([1:72])/n(72));
        % smoothing;
        fn2=part;fnaux=part;num2=max(size(fn2));
        for jj=1:100;
        fnaux(1)=0.5*fn2(1)+0.5*fn2(2);
        fnaux(num2-1)=0.5*fn2(num2-2)+0.5*fn2(num2-1);
        for ii=2:num2-2;fnaux(ii)=fn2(ii-1)*0.25+fn2(ii)*0.5+fn2(ii+1)*0.25;end;
        fn2=fnaux;
        end;
        part=fn2;   
        part=0.65*part/trapz(n,part.*fn);
        qmax=diff(w)*(1-PTR)*part.^(-1/eta);
    end;
    E=297/(258/0.75);% add nettax0 + 0% VAT on disposable income;
    
    
save simudat\UKfig.mat n fn fnorg norg nuk partspouse earnspouse tau0uk tau1uk tauspouseuk;  
end;    
    
lambda=0;

tau=0.6*ones(I+1,num); % these are vectors T'0,..,T'I;

%tau(2,:)=0.3*ones(1,num); % T'1;
%tau(1,:)=0.3*ones(1,num);
%tau(1,:)=0.0*4*((n-nmin)).*(nmax-n)/(nmax-nmin)^2;
%tau(2,:)=0.6*4*((n-nmin)).*(nmax-n)/(nmax-nmin)^2;

%for j=num/4:3*num/4;tau(1,j)=0;end;

taunew=tau;



qbar=zeros(I,num);
Vdot=zeros(I+1,num);
V=zeros(I+1,num);
Gam=zeros(I,num); % this is Gamma_i(qbar_i);
gam=zeros(I,num); % this is gamma_i(qbar_i);
P=zeros(I,num); % this is P_i, fraction in occupation i=1,..,I;
Pav=zeros(I,1); % this is P_i average across n;
Q=zeros(I,num); % this is Q_i=P_i+..+P_I, fraction in occupation i,..,I;
Qav=zeros(I,1); % this is Q_i average across n;
P0=zeros(1,num); % this P_0, fraction not working;
z=zeros(I+1,num);
c=zeros(I+1,num);
T=zeros(I+1,num);
dT=zeros(I,num); % this is T_1-T_0,..,T_I-T_I-1;

g=zeros(I+1,num); % marginal welfare weights at occup i;
G=zeros(I,num); % average marginal welfare weights for occupations i+..+I;
G0=zeros(1,num); % this G_0, fraction not working;
int=zeros(I+1,num); % auxilliary vectors;

adap=0.2; % main subroutine;
adap2=0.2; % auxiliary subroutine;

dTbig=zeros(20,I,num);taubig=zeros(20,I+1,num); % use to store the vectors dT, T'0, T'1 in iterative process; 

diffloop=10^10;j=0;diffold=diffloop;
diverg=0;
  
jjj=0;jjj2=0;

while abs(diffloop)>0.0000001*precis;
    %if diffold<diffloop;diverg=1;end;
    if diffold>=diffloop;diverg=0;end;
    diffold=diffloop;
    j=j+1 % counts the iterative steps
    diverg; % diverg=0 if process is converging, diverg=1 is process diverges
    adap % adaptative iterations;
    jjj=jjj+1; if jjj>=5 & adap<=0.1;adap=adap*2;end;
    
    tauold=tau;
    tau=adap*taunew+(1-adap)*tau;
    for i=1:I+1;
        z(i,:)=n.*(1-tau(i,:)).^e;
        Vdot(i,:)=(k/(k+1))*((z(i,:)./n).^(k+1));
        T(i,1)=0;
    end;
    
    aa=zeros(I,1);aa0=0;
    Taxtot=1;mutop=ones(I,1);
    jj=0;jjj2=0;
    absmutop=(sum(mutop.*mutop))^0.5;
    diff2loop=10^10;diff2old=diff2loop;
    
    
    % secondary iterative process to get the constants in V0 and V1 right so that transversality and budget constraint hold;
    while diff2loop>0.0000001*precis;
    
        jj=jj+1; % counts steps in secondary process
        %abs(Taxtot)+abs(absmutop)
        
        diff2old=diff2loop;
        %adap2, abs(Taxtot)+abs(absmutop) % adaptative iterations;
        jjj2=jjj2+1; if jjj2>=20 & adap2<=0.1;adap2=adap2*2;end;
        
        T(1,1)=T(1,1)+aa0;cuma=aa0;
        for i=1:I;
            cuma=cuma+aa(i);
            T(i+1,1)=T(i+1,1)+cuma;
        end;    
        V(:,1)=z(:,1)+w-(n(1)/(k+1))*(z(:,1)/n(1)).^(k+1)-T(:,1);
        
        for i=1:I+1;
            V(i,1)=z(i,1)+w(i)-(n(1)/(k+1))*(z(i,1)/n(1)).^(k+1)-T(i,1);
            V(i,:)=V(i,1)+cumtrapz(n,Vdot(i,:));
        end;    
        
        %for nn=2:num;
        %    V(:,nn)=V(:,nn-1)+(n(nn)-n(nn-1))*(Vdot(:,nn-1)+Vdot(:,nn))/2;
        %end;  
    
        for i=1:I;V(i,:)=max(V(i,:),epsi);end;
        
        for i=1:I;    
            qbar(i,:)=V(i+1,:)-V(i,:);qbar(i,:)=min(qbar(i,:),qmax(i,:)-epsi);qbar(i,:)=max(qbar(i,:),0+epsi);
            Gam(i,:)=(qbar(i,:)./qmax(i,:)).^eta(i);
            gam(i,:)=eta(i)*(qbar(i,:).^(eta(i)-1))./qmax(i,:).^eta(i);  
        end;
            
        % computing P_i;
        
        for i=1:I-1;
            P(i,:)=barh(i)*Gam(i,:)+barh(i+1)*(1-Gam(i+1,:));
        end;
        
        P(I,:)=barh(I).*Gam(I,:);
        P0=barh(1)*(1-Gam(1,:));
        
        Q(I,:)=P(I,:);
        
        for i=I-1:-1:1;
            Q(i,:)=Q(i+1,:)+P(i,:);
        end;
         
        
        for i=1:I+1;
            c(i,:)=V(i,:)+n.*((z(i,:)./n).^(1+k))/(1+k);
            T(i,:)=z(i,:)+w(i)-c(i,:);
        end;
    
        lambda=0;
        for i=1:I;
          aux=trapz(n,fn.*(V(i,:).^(-gamma).*(1-Gam(i,:))));
          aux=aux+trapz(n,fn.*(eta(i)*testfct(qbar(i,:)./V(i+1,:),eta(i),1-gamma).*(V(i+1,:).^(eta(i)-gamma))./(qmax(i,:).^eta(i))));
          lambda=lambda+aux*barh(i);
        end;    
        
        % g0;
        g(1,:)=V(1,:).^(-gamma)/lambda;
        
        for i=1:I-1;
          % gi, i=1,..,I-1;
          g(i+1,:)=barh(i)*eta(i)*testfct(qbar(i,:)./V(i+1,:),eta(i),1-gamma).*(V(i+1,:).^(eta(i)-gamma))./(qmax(i,:).^eta(i));  
          g(i+1,:)=g(i+1,:)+barh(i+1)*(1-Gam(i+1,:)).*V(i+1,:).^(-gamma);
          g(i+1,:)=g(i+1,:)./(P(i,:)*lambda);
        end;    
        
        % gI;
        g(I+1,:)=eta(I)*testfct(qbar(I,:)./V(I+1,:),eta(I),1-gamma).*(V(I+1,:).^(eta(I)-gamma))./(lambda*qbar(I,:).^eta(I));
          
        G(I,:)=P(I,:).*g(I+1,:);
        for i=I-1:-1:1;
            G(i,:)=G(i+1,:)+P(i,:).*g(i+1,:);
        end;
        G0=G(1,:)+P0.*g(1,:);
        
        for i=1:I;
            G(i,:)=G(i,:)./Q(i,:);
        end;    
        
        for i=1:I;
            mutop(i)=trapz(n,fn.*((1-G(i,:)).*Q(i,:)-barh(i)*(T(i+1,:)-T(i,:)).*gam(i,:)));
        end;
        
       % note that this is the transversality condition using the Q_i=P_i+..+P_I;
        
        
        Taxtot=trapz(n,fn.*(P0.*T(1,:)));
        for i=1:I;
            Taxtot=Taxtot+trapz(n,fn.*(P(i,:).*T(i+1,:)));
        end;
        Taxtot=Taxtot-E;
        
        
        % need to change constants to get newT0=newT0+aa0, .., newTi=Ti+aa0+aa1+..+aai;
        % aai=mutop(i)/ int (barh_i gamma_i f(n)dn);
        % aa0=-[Taxtot+aa1*Qav_1+..+aaI*Qav_I];
        
        for i=1:I;
            Pav(i)=trapz(n,fn.*P(i,:));
            aa(i)=mutop(i)/trapz(n,barh(i)*fn.*gam(i,:));
        end;
        Qav(I)=Pav(I);for i=I-1:-1:1;Qav(i)=Qav(i+1)+Pav(i);end;
        
        aa0=-Taxtot;for i=1:I;aa0=aa0-aa(i).*Qav(i);end;    
        
        aa0=adap2*aa0;for i=1:I;aa(i)=adap2*aa(i);end; % I do this to avoid cycles for gamma large;
    
        aa=real(aa);aa0=real(aa0);
        
        
        absmutop=(sum(mutop.*mutop))^0.5;
        diff2loop=abs(Taxtot)+abs(absmutop);
        
        if diff2old<diff2loop;jjj2=0;adap2=adap2/2;aa=zeros(I,1);aa0=0;end;
        
        %if diverg==1 & jj>=10;Taxtot=0;absmutop=0;end;
        if jj>100;diff2loop=0;end;
        
    end; 
  
    for i=1:I;dT(i,:)=T(i+1,:)-T(i,:);end;
     
    % social welfare;
    
    SWF=0;
    %if gamma~=1; % not equal to 1;
    %SWF=(1/(1-gamma))*trapz(n,fn.*(V0.^(1-gamma).*(1-Pq)+eta*testfct(qbar./V1,eta,2-gamma).*(V1.^(1+eta-gamma))/(qmax^eta)));
    %end;
    %if gamma==1;
    %SWF=trapz(n,fn.*(log(V0).*(1-Pq)+(((V1-V0).^eta).*log(V0)+testfct(qbar./V1,eta+1,1-gamma).*(V1.^eta))/(qmax^eta)));
    %end;
    
    int(1,:)=cumtrapz(n,fn.*((g(1,:)-1).*P0-dT(1,:).*barh(1).*gam(1,:)));
    for i=1:I-1;
        int(i+1,:)=cumtrapz(n,fn.*((g(i+1,:)-1).*P(i,:)+dT(i,:).*barh(i).*gam(i,:)-dT(i+1,:).*barh(i+1).*gam(i+1,:)));
    end;
    int(I+1,:)=cumtrapz(n,fn.*((g(I+1,:)-1).*P(I,:)+dT(I,:).*barh(I).*gam(I,:)));
    
    for i=1:I+1;int(i,:)=int(i,:)-int(i,num);end; % adjust to get zero top result;
   
    taunew(1,:)=(1/e)*(1./(n.*fn)).*(1./P0).*int(1,:);
    taunew(1,:)=taunew(1,:)./(1+taunew(1,:));
    for i=2:I+1;
        taunew(i,:)=(1/e)*(1./(n.*fn)).*(1./P(i-1,:)).*int(i,:);
        taunew(i,:)=taunew(i,:)./(1+taunew(i,:));
    end;
    
    if taunew~=real(taunew);
        imagin=1
    end;    
    
    taunew=real(taunew); % new add-on;
    
    diffloop=0;
    for i=1:I+1;
        diffloop=diffloop+sum((tau(i,:)-taunew(i,:)).^2);
    end;    
    diffloop=diffloop
    if j<=20
    dTbig(j,:,:)=dT;
    taubig(j,:,:)=tau;
    end;

    %znew=z;
    %for i=1:I+1;znew(i,:)=n.*(1-taunew(i,:)).^(1/k);end;
    %plot(n,znew,n,z);
    %glue; 
    
    
    
    if diffold<diffloop;
        diverg=1;jjj=0;if adap>0.02;adap=adap/2;end;
        if adap<=0.02;adap=0.1*(1+0.25*rand(1));end;
        taunew=tau;tau=tauold;
    end;
   
   
   
   
end;
    
tauspouse=zeros(I,num);
for i=1:I;tauspouse(i,:)=(w(i+1)-w(i)-qbar(i,:))/(w(i+1)-w(i));end;
    
% computing spousal elasticities;

etatrue=ones(I,num);etaav=ones(I,1);epsispouse=ones(I,1);
for i=1:I;
    etatrue(i,:)=barh(i)*gam(i,:).*qbar(i,:)./P(i,:);
    etaav(i)=trapz(n,fn.*etatrue(i,:));
    epsispouse(i)=etaav(i).*(w(i+1)-w(i))/w(i);    
end;


plot(n,tau,n,tauspouse);


% need to recompute Tz which is T but keeping z constant instead of n;
% I compute T using z(1,:)=z0 as the base;

Tz=T;
for i=2:I+1;
    for nb=1:num;
        nn=1;
        while z(i,nn)<z(1,nb) & nn<num;nn=nn+1;end;
        % z(i,nn-1)<z(1,nb)<z(i,nn);
        if nn==1;Tz(i,nb)=T(i,nn);end;
        if nn>num;Tz(i,nb)=T(i,num);end;
        if nn>1 & nn<=num;
            wei=(z(1,nb)-z(i,nn-1))/(z(i,nn)-z(i,nn-1));
            Tz(i,nb)=(1-wei)*T(i,nn-1)+(wei)*T(i,nn);
        end;
    end;    
end;
    
    
% plot(n,1-g(1,:)+dT.*gam./P,n,1-g(2,:)-dT.*gam./(1-P));


